//
// fragment shader for PCF with 5 samples Shadow Maps
//

#define	EPS		0.05
#define	fSize	0.2

uniform sampler2D		mainMap;
uniform sampler2DShadow	shadowMap;

void main (void)
{
	vec3 	offs [4];
	vec4	clr  = texture2D ( mainMap, gl_TexCoord [0].xy );
	vec4	tex  = gl_TexCoord [1] / gl_TexCoord [1].w;
	float	sh   = shadow2D ( shadowMap, tex.xyz ).x;
	
	offs [0] = vec3 ( 0.02,  0.0,  0.0 );
	offs [1] = vec3 ( 0.01,  0.01, 0.0 );
	offs [2] = vec3 ( 0.0,  -0.02, 0.0 );
	offs [3] = vec3 ( 0.01, -0.01, 0.0 );
		
	for ( int i = 0; i < 4; i++ )
		sh += shadow2D ( shadowMap, tex.xyz + fSize * offs [i] ).x;
		
	gl_FragColor = clr *  sh * 0.2;
}
